#ifndef _LOG_H
#define _LOG_H
extern int LOG_type;
extern int LOG_type2;
extern int LOG_bugs;

#define L_LEVEL		0x0000000F
#define LOGLEVEL	(LOG_type&0xF)

#define L_SYNC		0x00000010
#define L_FG		0x00000020
#define L_TTY		0x00000040
#define L_CONSOLE	0x00000080
#define L_SILENT	0x00000100
#define	L_TERSE		0x00000200
#define L_VERB		0x00000400
#define L_EXEC		0x00000800
#define L_FORK		0x00001000
#define L_STICK		0x00002000
#define L_LOCK		0x00004000
#define L_FILETRACE	0x00008000
#define L_ARGDUMP	0x00010000
#define L_VERBABORT	0x00020000
#define L_MEMPUSH	0x00040000
#define L_SOCKET	0x00080000
#define L_HOSTMATCH	0x10000000
#define L_MOUNT		0x20000000
#define L_RAND_TRACE	0x40000000

#define L_TRACE		0x00100000
#define L_NOEXEC	0x00200000
#define L_TRVERB	0x00400000
#define L_TRTERSE	0x00800000
#define L_SIGCHLD	0x01000000
#define L_REINIT	0x02000000
#define L_ISCHILD	0x04000000
#define L_ISFUNC	0x08000000

#define lSYNC()	  	(LOG_type & L_SYNC)
#define lFG()	  	(LOG_type & L_FG)
#define lTTY()	  	(LOG_type & L_TTY)
#define lSILENT()	(LOG_type & L_SILENT)
#define lTERSE()  	(LOG_type & L_TERSE)
#define lVERB()	  	(LOG_type & L_VERB)
#define lEXEC()   	(LOG_type & L_EXEC)
#define lFORK()	  	(LOG_type & L_FORK)
#define lSTICK()  	(LOG_type & L_STICK)
#define lLOCK()	  	(LOG_type & L_LOCK)
#define lFILETRACE()	(LOG_type & L_FILETRACE)
#define lARGDUMP()	(LOG_type & L_ARGDUMP)
#define lVERBABORT()	(LOG_type & L_VERBABORT)
#define lMEMPUSH()	(LOG_type & L_MEMPUSH)
#define lMOUNT()	(LOG_type & L_MOUNT)
#define lSOCKET()	(LOG_type & L_SOCKET)

#define L_TIMEFMT	0x00000007
#define L_FILEDESC	0x00000008
#define lFILEDESC()	(LOG_type2 & L_FILEDESC)
#define L_CHARSET	0x00000010
#define lCHARSET()	(LOG_type2 & L_CHARSET)
#define L_GATEWAY	0x00000020
#define lGATEWAY()	(LOG_type2 & L_GATEWAY)
#define L_SEXEC		0x00000040
#define lSEXEC()	(LOG_type2 & L_SEXEC)
#define L_CRYPT		0x00000080
#define lCRYPT()	(LOG_type2 & L_CRYPT)
#define L_RCONFIG	0x00000100
#define lRCONFIG()	(LOG_type2 & L_RCONFIG)
#define L_HTMLGEN	0x00000200
#define L_HTMLGENV	0x00000400
#define lHTMLGEN()	(LOG_type2 & (L_HTMLGENV|L_HTMLGEN))
#define lHTMLGENV()	(LOG_type2 & L_HTMLGENV)
#define L_STRICT	0x00001000
#define lSTRICT()	(LOG_type2 & L_STRICT)
#define L_LOCKSHARED	0x00002000
#define L_SPAWNLOG	0x00004000
#define lSPAWNLOG()	(LOG_type2 & L_SPAWNLOG)
#define L_PATHFIND	0x00008000
#define lPATHFIND()	(LOG_type2 & L_PATHFIND)
#define L_SECRET	0x00010000
#define lSECRET()	(LOG_type2 & L_SECRET)
#define L_URLFIND	0x00020000
#define lURLFIND()	(LOG_type2 & L_URLFIND)
#define L_EMU_NOFORK	0x00040000
#define lEMU_NOFORK()	(LOG_type2 & L_EMU_NOFORK)
#define L_NO_VSNPRINTF	0x00080000
#define lNO_VSNPRINTF()	(LOG_type2 & L_NO_VSNPRINTF)
#define L_TLS		0x00100000
#define lTLS()		(LOG_type2 & L_TLS)
#define L_ACCESSCTL	0x00200000
#define lACCESSCTL()	(LOG_type2 & L_ACCESSCTL)
#define L_DEBUGMSG	0x00400000
#define lDEBUGMSG()	(LOG_type2 & L_DEBUGMSG)
#define L_COUNTER	0x00800000
#define lCOUNTER()	(LOG_type2 & L_COUNTER)
#define L_FILEOPEN	0x01000000
#define lFILEOPEN()	(LOG_type2 & L_FILEOPEN)
#define L_NOINITLOG	0x02000000
#define lNOINITLOG()	(LOG_type2 & L_NOINITLOG)
#define L_NOPROTOLOG	0x04000000
#define lNOPROTOLOG()	(LOG_type2 & L_NOPROTOLOG)
#define L_DEBUGLOCK	0x08000000
#define lDEBUGLOCK()	(LOG_type2 & L_DEBUGLOCK)
#define L_NO_WSOCKWA	0x10000000
#define lNO_WSOCKWA()	(LOG_type2 & L_NO_WSOCKWA)
#define L_DYLIB		0x20000000
#define lDYLIB()	(LOG_type2 & L_DYLIB)
#define L_POLL		0x40000000
#define lPOLL()		(LOG_type2 & L_POLL)
#define L_SECUREEXT	0x80000000
#define lSECUREEXT()	(LOG_type2 & L_SECUREEXT)

#define lTRACE()	(LOG_type & L_TRACE)
#define lNOEXEC()	(LOG_type & L_NOEXEC)
#define lTRVERB()	(LOG_type & L_TRVERB)
#define lTRTERSE()	(LOG_type & L_TRTERSE)
#define lSIGCHLD()	(LOG_type & L_SIGCHLD)
#define lISCHILD()	(LOG_type & L_ISCHILD)
#define lISFUNC()	(LOG_type & L_ISFUNC)

#define ENBUG_WINSOCKFD	(LOG_bugs & 1)

#define LW_CREATE	1
#define LW_EXMATCH	2

typedef struct _Logfile {
  const	char	*l_proto;
  const	char	*l_filters;	/* depend on l_proto */
  const	char	*l_pform;	/* template of path */
	defQStr(l_path);
  const	char	*l_lform;	/* format of log data */
  const	char	*l_mode;	/* mode of fopen */
	FILE	*l_fp;
	int	 l_dolock;	/* do lock */
	int	 l_lockfd;	/* extra lock file */
  const	char	*l_lkpath;
	int	 l_until;
	defQStr(l_buff);
	int	 l_size;
	int	 l_leng;
	int	 l_abandon;
	int	 l_notty;
	int	 l_dontfree;
} Logfile;

Logfile *LOG_which(PCStr(proto),PCStr(filter1),int options);
void LOG_write(Logfile *LogF,PCStr(str),int leng);
void LOG_flushall();

extern const char LS_VERBOSE[]; /* V */
extern const char LS_DEBUG[]; /* D */
extern const char LS_USUAL[]; /* U (or normal, nutoral) */
extern const char LS_TERSE[]; /* T (or trace) */
extern const char LS_ERROR[]; /* E */
extern const char LS_FATAL[]; /* F */
extern const char LS_ACCESS[]; /* A */

extern char LP_NOTTY[]; /* don't merge to tty even with -v option */
extern char LF_PROTOLOG[];
extern char LF_ERRORLOG[];
extern char LF_TRACELOG[];
extern char LF_LOGFILE[];
extern const char *(*LOG_stdlogfile)();
/*
extern int   (*LOG_substfile)(void*,...);
*/

extern int LOG_VERBOSE;
#define	Verbose	(LOG_VERBOSE==0 && lVERBABORT()==0) ? 0 : sv1vlog
#define LSEC (LOG_type2 & L_SECRET) == 0 ? 0 : syslog_ERROR

#define InitLog	(lISCHILD()||lISFUNC()) ? 0:syslog_ERROR

#define HLdebug (LOG_type&L_HOSTMATCH)==0?0:putLog0

#define CCXlog lCHARSET()==0?0:syslog_ERROR

#define P_LV (LOGLEVEL<3) ? 0:porting_dbg

void iLOGinit();
void iLOGdump(int sig,PCStr(fmt),...);
#define iLOGstop()	(LOG_type2 |= L_NOINITLOG)
int iLOGpos(PCStr(F),int L);
int iLOGput(PCStr(fmt),...);

#define iLog \
    (((lNOINITLOG() && LOGLEVEL < 2)?0:iLOGpos(__FILE__,__LINE__)),\
      (lNOINITLOG() && LOGLEVEL < 2))?0:iLOGput

#endif /* _LOG_H */
